// Fig. 11.32: PaintPanel.java
// Using class MouseMotionAdapter.
import java.awt.Color;
import java.awt.Point;
import java.awt.Graphics;

import java.awt.event.*;
import javax.swing.JPanel;

public class PaintPanel extends JPanel 
{
   private Color color;
   private Point newPoint;  
   private Point oldPoint; 
   private boolean shouldPaint; 
  
   // set up GUI and register mouse event handler
   public PaintPanel(Color c)
   {
   	  color= c; // default
          newPoint = new Point();
   	  oldPoint = new Point();
   	  shouldPaint = false;
    
          // handle frame mouse motion event
          addMouseMotionListener(new MouseMotionHandler());
          addMouseListener(new MouseHandler());
 
   } // end PaintPanel constructor
  private  class MouseMotionHandler extends MouseMotionAdapter{
                 // store drag coordinates and repaint
            public void mouseDragged( MouseEvent event )
            {
               if ( shouldPaint ) 
               {
                  newPoint.x = event.getX();
                  newPoint.y = event.getY();
                  if (shouldPaint)
                  {
                 // draw all points in array
                     Graphics g = getGraphics(); 
                     g.drawLine( oldPoint.x, oldPoint.y, newPoint.x, newPoint.y );
                     oldPoint.x = newPoint.x;
                     oldPoint.y = newPoint.y;
                  }
                  
                  // repaint JFrame
               } // end if
            } // end method mouseDragged 
  }
   private class MouseHandler extends MouseAdapter{
        // store drag coordinates and repaint
            public void mousePressed( MouseEvent event )
            {
               shouldPaint = true;
               Graphics g = getGraphics(); 
               g.setColor(color);
               oldPoint.x = event.getX();
               oldPoint.y = event.getY();
               
            } // end method mousePressed
             public void mouseReleased( MouseEvent event )
            {
               shouldPaint = false;
               
            } // end method mouseReleased
   }
   public void setColor(Color c){
       color = c;
   }
} // end class PaintPanel

